// C Source File

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Title:        AGENDA V4.2  oooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Author:       Adrian Bader o - o A.Bader@gmx.ch ooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
// -- Best viewed with TAB-STOP 4! ------------------------------------------
// --------------------------------------------------------------------------


#include "IncludeAll.h"

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

char *NotepadGetBasePtr ()
{
	return (gr_Agenda->DataFile.DataPtr + gr_Agenda->DataFile.Header->NotesPtr);
}

// --------------------------------------------------------------------------

unsigned int NotepadGetBaseSize ()
{
	return (gr_Agenda->DataFile.Header->NotesSize);
}

// --------------------------------------------------------------------------

void AdjustNotepadSize (long int SizeDelta)
{
	gr_Agenda->DataFile.Header->NotesSize += SizeDelta;
	gr_Agenda->DataFile.Header->INetLinksPtr += SizeDelta;
}

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int GetNoteNames (TEntryType *ET, int GroupNr, HANDLE *handle)
{
	int				Ret			= ER_SUCCESS;
	unsigned long	size		= 0;
	unsigned int	dPos		= 0;
	char			*pos;
	long			dSize;
	char			*Title;
	TEntryHeader	*Header;
	
	*handle = HeapAlloc (2);
	if (*handle == H_NULL) Ret = ER_MALLOC;
	
	if (Ret == ER_SUCCESS)
	{
		Ret = GetGroup (ET, NULL, GroupNr, &Header);
		if (Ret == ER_SUCCESS)
		{
			Header = (TEntryHeader *)( (char *)Header + Header->Size);
			while ( ((Header->Flags & FLAG_ET_MASK) == FLAG_ET_ENTRY) && (Ret == ER_SUCCESS) )
			{
				Title = &Header->data;
				dSize = strlen (Title) + 4;
				if  ( HeapRealloc (*handle, size += dSize) == H_NULL ) Ret = ER_MALLOC;
				else
				{
					pos = HeapDeref (*handle);
					strcpy (pos + dPos, Title);
					dPos += strlen (Title) +1;
				}
				Header = (TEntryHeader *)( (char *)Header + Header->Size);
			}
		}
		poke (HeapDeref (*handle) + dPos++, '\0');
		poke (HeapDeref (*handle) + dPos, '\0');
		if (Ret == ER_GROUP_NOT_FOUND) Ret = ER_SUCCESS;
	}
	
	if (Ret == ER_MALLOC) HeapFreeHNULL (handle);

	return Ret;

}


// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
