// C Header File

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Title:        AGENDA V4.2  oooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Author:       Adrian Bader o - o A.Bader@gmx.ch ooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
// -- Best viewed with TAB-STOP 4! ------------------------------------------
// --------------------------------------------------------------------------


#ifndef		__HDATE__
#define		__HDATE__

// --------------------------------------------------------------------------
// --- Structures -----------------------------------------------------------
// --------------------------------------------------------------------------

	extern int		easterRel[9];
	extern char		easterIDs[9];

	extern int		absDays[3];
	extern char		absDaysIDs[3];
	
	extern int		relDays[11];
	extern char		relDaysIDs[11];
	
	extern char		g_optionTable[2][8];

typedef struct				// don't change order. DFAgena.GetBirthdays() uses it like this.
{							// (MonthDay first !)
	int		MonthDay;
	int		Month;
	int		Year;
	int		WeekDay;
	int		Week;
} TDate;


typedef struct
{
	int		order;
	char	delimiter;
	int		delNum;			// used for fast access to delimiter flags number
} TDateFormat;


// --------------------------------------------------------------------------
// --- Prototypes -----------------------------------------------------------
// --------------------------------------------------------------------------

int 			convertDates (char *buf, HANDLE *handle, int old, int new, int rangeCheck);
int 			convertAddressbookDates (int new, int old);
int 			readDateFormat ();
void 			writeDateFormat (int option);
TDateFormat 	getDateOptions ();
void 			getDateString (unsigned int day, TDate *pdate, char *buf, int flags, TDateFormat *df);
int 			getToday (unsigned int *Day);
void 			GetDate (unsigned int Day, TDate *Date);
void 			GetDateEx (unsigned int Day, TDate *Date);
int				GetWeek (unsigned int Day);
unsigned int 	GetDay (TDate Date);
int 			GetEasterSunday (int year);

int 			GetDayFromStrDate (char *StrDate, TDate *Date, unsigned int *Day, int rangeCheck);
int 			GetDayFromStrDateEx (char *strDate, HANDLE *handle, int rangeCheck);

void 			writeHashTbl (int idx, unsigned int value, int from);
unsigned int 	readHashTbl (int idx, int from);

void 			fillDayList (int year, int offset, int *Days, char *IDs, int num, int lstStart);
int				fillHashTable (unsigned int Day, int force);
unsigned int 	ReadDayWithExtraData (unsigned int Day);
int				getExtraInfoCount (unsigned int Day);


// date display options consts:

#define		DMY					0
#define		MDY					1
#define		YMD					2

#define		FLAG_USE_YEAR		1
#define		FLAG_LONG_YEAR		2
#define		FLAG_USE_WEEKDAY	4

#define		DATE_ENDLIST		-1

// Hashtable consts:

#define		HASH_TBL_OVERLAP	25
#define		HASH_PUBLIC_HDAY	0x00FF		// to mask the public holidays

#define		NEW_YEARS_DAY		0x0001
#define		EPIPHANY			0x0002
#define		VALENTIN_DAY		0x0003

#define		ASH_WEDNESDAY		0x0004
#define		PALM_SUNDAY			0x0005
#define		GOOD_FRIDAY			0x0006
#define		EASTER_SUNDAY		0x0007
#define		EASTER_MODAY		0x0008
#define		ASCENSION_DAY		0x0009
#define		WHITSUNTIDE			0x000A
#define		WHIT_MONDAY			0x000B
#define		CORPUS_CHRISTI		0x000C

#define		SPRING				0x000D
#define		MAY_FIRST			0x000E
#define		SOMMER				0x000F
#define		THE_ASSUMTION		0x0010
#define		AUTUMN				0x0011
#define		ALL_SAINTS_DAY		0x0012
#define		WINTER				0x0013
#define		SAINT_EVENING		0x0014
#define		CHRISTMAS_DAY		0x0015
#define		BOXING_DAY			0x0016
#define		NEW_YEARS_EVE		0x0017

#define		HASH_BIRTHDAY		0x0100
#define		HASH_AUTO_FIELD		0x0200
#define		NORMAL_ENTRY		0x0400		// used in ReadDayWithExtraData

// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo

#endif
