// C Source File

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Title:        AGENDA V4.2  oooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Author:       Adrian Bader o - o A.Bader@gmx.ch ooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
// -- Best viewed with TAB-STOP 4! ------------------------------------------
// --------------------------------------------------------------------------


#include "IncludeAll.h"

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

void DisplayAddressRow (HANDLE *hBuf, int row)
{
	char		RowBuf[40];

	memcpy (RowBuf, HeapDeref (hBuf[row]), 24);
	RowBuf[24] = '\0';
	ScrRectFill ( &(SCR_RECT){{84, row*11+3+15-1, 228, row*11+3+11+15-1}}, ScrRect, A_REVERSE);
	printf_xy (84, row*11+3+15, RowBuf);
}

// --------------------------------------------------------------------------

int AllBlank (TEntryType *ET, HANDLE hBuf[])
{
	int		i;
	int		Ret = 1;
	
	for (i = 0; i < ET->NumStrings; i++)
	{
		if (peek (HeapDeref (hBuf[i])) != 0) Ret = 0;
	}
	
	return Ret;
}

// --------------------------------------------------------------------------

int checkValidBirthday (HANDLE *hBuf, int row)
{
	int		Ret 		= ER_SUCCESS;
	int		format		= readDateFormat();
	HANDLE	hNewDates	= H_NULL;
	
	// --- if Birthday field changed
	if (row == 7)
	{
		Ret = convertDates (HeapDeref (hBuf[7]), &hNewDates, format, format, 0);
		if (Ret == ER_SUCCESS)
		{
			if (HeapRealloc (hBuf[7], strlen (HeapDeref (hNewDates))+1) == H_NULL) Ret = ER_MALLOC;
			else
			{
				strcpy (HeapDeref (hBuf[7]), HeapDeref (hNewDates));
			}
		}
		HeapFreeHNULL (&hNewDates);
	}
	
	return Ret;
}

// --------------------------------------------------------------------------
// --- *hBuf points to an array of 9 handles. They must be H_NULL, when they
// --- should be initialized in this function. ------------------------------
// --- The handles must be released after the call to this function. --------
// --------------------------------------------------------------------------

int CreateAddress (TEntryType *ET, HANDLE *hBuf, int GroupNr)
{
	int				Ret 			= ER_SUCCESS;
	int				lines			= 9;
	int				CursorPos		= 0;
	int				key				= 0;
	int				Action			= 0;
	int				mustclosewin	= 0;
	int				move;
	int				CursorBefore;
	int				CursorBlink;
	int				y;
	char			Title[80];
	TEXT_EDIT		te;
	EVENT			ev;
	WINDOW			Win;
	TIdleLoop		idl;
	
	idl.Task = TASK_ADDRESSBOOK;
	lastEditorMode (ET->Task, 1);
	
		
	if (!WinOpen (&Win, MakeWinRect (4, 15, 235, 116), WF_NOBORDER)) Ret = ER_MALLOC;
	if (Ret == ER_SUCCESS)
	{
		mustclosewin = 1;
		EmptyScreenClient();
		FontSetSys (F_6x8);
		PrintHeadBox (LVGetHeadTitle (ET, GroupNr, Title) );
		InitHandles (hBuf, 9);
		for (y = 0; y < lines; y++)
		{
			printf_xy (10, y*11+18, GetStrFromList (ADDRESS_FIELDS, y));
			DisplayAddressRow (hBuf, y);	
		}
	}
	
	if (Ret == ER_SUCCESS)
	{
		CursorBlink = CU_start ();
		Win.Flags &= ~WF_DIRTY;
		while (!Action && !gr_Agenda->Exit && Ret == ER_SUCCESS)
		{
			if ( TE_open (&te, &Win, MakeWinRect (80, CursorPos*11+3, 224, CursorPos*11+3+10), hBuf[CursorPos], 0, 0, 0) )
			{
				TE_focus (&te);
				move = 0;
				while ( !move && !Action && !gr_Agenda->Exit)
				{
					CursorBefore = CursorPos;
					move = 1;
					IdleLoop (&idl, ILF_NOMENU, &key, NULL, &ev);  
					if ( (key == KEY_DOWN) && (CursorPos < 8) ) CursorPos++;
					else if ( (key == KEY_UP) && (CursorPos > 0) ) CursorPos--;
					else if (key == KEY_ESC) Action = OK;
					else if (key == KEY_2ND + KEY_ESC) Action = CANCEL;
					else if (key == KEY_ENTER) 
					{
						if (CursorPos < 8) CursorPos++;
						else Action = OK;
					}
					else
					{
						move = 0;
						TE_handleEvent (&te, &ev);
					}
					if (move)
					{
						Ret = checkValidBirthday (hBuf, CursorBefore);
						TE_unfocus (&te);
						DisplayAddressRow (hBuf, CursorBefore);
					}
				}
			}
			else Ret = ER_MALLOC;
			
			if (Action == OK)
			{
				if ( AllBlank (ET, hBuf) ) Action = CANCEL;
				else if (peek(HeapDeref(hBuf[0])) == 0)
				{
					if (MsgBox (MSG_TITLE_HINT, MSG_FIELD_REQUIRED, BT_OK, BT_CANCEL) == OK) Action = CANCEL;
					else Action = 0;
				}
			}
			
			if (gr_Agenda->Exit)
			{
				Action = OK;
				if (peek(HeapDeref(hBuf[0])) == 0) Action = CANCEL;
			}
		}
		CU_restore (CursorBlink);
	}
	
	if ( !gr_Agenda->Exit)
	{
		lastEditorMode (ET->Task, 0);
	}

	
	if (mustclosewin) WinRemove (&Win, 0);
	if (Ret == ER_SUCCESS) Ret = Action;
	
	return Ret;
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
