// C Header File

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Title:        AGENDA V4.2  oooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Author:       Adrian Bader o - o A.Bader@gmx.ch ooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
// -- Best viewed with TAB-STOP 4! ------------------------------------------
// --------------------------------------------------------------------------


#ifndef		__HDISPLAYLV__
#define		__HDISPLAYLV__

// --------------------------------------------------------------------------
// --- structures -----------------------------------------------------------
// --------------------------------------------------------------------------

typedef struct
{
	int				Redraw;
	int				Reassign;
	int				key;
	int				Focus;
	int				GroupNr;
	int				DatasetNr;
	int				noDataset;
	int				noGroup;
	int				GroupCursor;
	int				DSCursor;
	TScrollList		SLGroups;
	TScrollList		SLNames;
	HANDLE			hGroups;
	HANDLE			hNames;
} TListView;

// --------------------------------------------------------------------------
// --- Prototypes -----------------------------------------------------------
// --------------------------------------------------------------------------

int		LVView (int Task);
char 	*LVGetHeadTitle (TEntryType *ET, int GroupNr, char *Buf);
int 	LVFocusGroups (TEntryType *ET, TListView *LV);
int 	LVFocusNames (TEntryType *ET, TListView *LV);
void 	LVCheckData (TListView *LV, int Check);
int 	LVReassignData (TEntryType *ET, TListView *LV);
void 	LVRedrawLists (TListView *LV, short Lists);
void 	LVRedraw (TListView *LV, TEntryType *ET);
int 	LVInit (TEntryType *ET, TListView *LV);
int 	ShowListView (TEntryType *ET, int *groupNr, int *datasetNr, int *mode);

int 	LVonMenuClose (void *ptr1, void *ptr2, int Tag1, int Tag2, int DidWhat, int Feedback);
int 	LVonMenuOpen (void *ptr1, void *ptr2, int *Tag1, int *Tag2);

// --------------------------------------------------------------------------
// --- Defines --------------------------------------------------------------
// --------------------------------------------------------------------------

#define		DA_REDRAW_INIT		1
#define		DA_REDRAW_LG		2
#define		DA_REDRAW_LN		4
#define		DA_REDRAW_SHR_L		1


// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo

#endif

