// C Source File

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Title:        AGENDA V4.2  oooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Author:       Adrian Bader o - o A.Bader@gmx.ch ooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
// -- Best viewed with TAB-STOP 4! ------------------------------------------
// --------------------------------------------------------------------------


#include "IncludeAll.h"

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int IsAgendaEventKey (int key)
{
	int		Ret = 0;
	
	if ( ( key == KEY_ENTER ) ||
		 ( key == KEY_BACKSPACE ) ||
	     ( key == KEY_APPS ) ||
	     ( key == KEY_DIAMOND + 'D' ) ||
	     ( key == KEY_DIAMOND + 'M' ) ||
	     ( key == KEY_DIAMOND + 'W' ) ||
	     ( key == KEY_DIAMOND + 'Y' ) ||
	     ( key == KEY_DIAMOND + 'K' ) ||
	     ( key == 'N' || key == 'n' ) ||
	     ( key == '+' && D_AgendaViewMode != SECOND_VIEW ) ||
	     ( key == '-' && D_AgendaViewMode != NORMAL_VIEW ) ||
	     ( gr_Agenda->UseClock && (key == KEY_DIAMOND + 'T') )
	   ) Ret = 1;
	   
	return Ret;
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int MenuAgenda (unsigned int *Day, int *Repaint, int key, int *DidWhat)
{
	int				Ret			= ER_SUCCESS;
	int				idx			= -1;
	unsigned int	DayBefore	= *Day;
	HANDLE 			handle;
	int				hasPlan		= ReadDay (*Day, NULL) != NULL;

	DrawMainCursor(OFF, *Day);

	if (key == KEY_APPS)
	{
		if ( (handle = PopupNew ((char *)MA_TITLE, 100) ) == H_NULL) Ret = ER_MALLOC;
		else
		{
			PopupAddText (handle, 0, MA_GOTO, RET_MA_GOTO);
			PopupAddText (handle, RET_MA_GOTO, MG_DAY, RET_MG_DAY);
			if (gr_Agenda->UseClock) PopupAddText (handle, RET_MA_GOTO, MG_TODAY, RET_MG_TODAY);
			PopupAddText (handle, RET_MA_GOTO, MG_ENTRY, RET_MG_ENTRY);
			PopupAddText (handle, RET_MA_GOTO, MG_WEEK, RET_MG_WEEK);
			PopupAddText (handle, RET_MA_GOTO, MG_YEAR, RET_MG_YEAR);
			PopupAddText (handle, 0, MA_DEL, RET_MA_DEL);
			PopupAddText (handle, RET_MA_DEL, MD_DAY, RET_MD_DAY);
			PopupAddText (handle, RET_MA_DEL, MD_OLD, RET_MD_OLD);
			PopupAddText (handle, RET_MA_DEL, MD_AREA, RET_MD_AREA);
			PopupAddText (handle, RET_MA_DEL, MD_WHOLE, RET_MD_WHOLE);
			PopupAddText (handle, 0, MA_VIEW, RET_MV_VIEW);
			if (D_AgendaViewMode == NORMAL_VIEW)
				PopupAddText (handle, RET_MV_VIEW, MA_VIEW_MONTH, RET_MV_MONTH_VIEW);
			else
				PopupAddText (handle, RET_MV_VIEW, MA_VIEW_WEEK, RET_MV_NORMAL_VIEW);
			PopupAddText (handle, -1, MA_MOVE, RET_MA_MOVE);
			if (hasPlan) PopupAddText (handle, -1, MA_SHORTCUT, RET_MA_SHORTCUT);
			if (MenuFlags (handle) & MF_ERROR) Ret = ER_MALLOC;
			else idx = PopupDo (handle, 10, 60, 0);
			HeapFree (handle);
			stIdle();
		}
	}

	if (key == (KEY_DIAMOND + 'D')) idx = RET_MG_DAY;
	if (key == 'N' || key == 'n') idx = RET_MG_ENTRY;
	if (key == (KEY_DIAMOND + 'W')) idx = RET_MG_WEEK;
	if (key == (KEY_DIAMOND + 'Y')) idx = RET_MG_YEAR;
	if (key == KEY_BACKSPACE) idx = RET_MD_DAY;
	if (key == (KEY_ENTER)) idx = RET_MA_EDITDAY;
	if (key == (KEY_DIAMOND + 'T')) idx = RET_MG_TODAY;
	if (key == (KEY_DIAMOND + 'M')) idx = RET_MA_MOVE;
	if (hasPlan && (key == (KEY_DIAMOND + 'K'))) idx = RET_MA_SHORTCUT;
	if (key == '+') idx = RET_MV_MONTH_VIEW;
	if (key == '-') idx = RET_MV_NORMAL_VIEW;

	switch (idx)
	{
		case RET_MG_DAY:
				Ret = MenuGotoDay (Day);
				break;

		case RET_MG_TODAY:
				Ret = MenuGotoToday (Day);
				break;

		case RET_MG_ENTRY:
				Ret = MenuGotoNextEntry (Day);
				break;
				
		case RET_MG_WEEK:
				Ret = MenuGotoWeek (Day);
				break;

		case RET_MG_YEAR:
				Ret = MenuGotoYear (Day);
				break;

		case RET_MD_WHOLE:
				Ret = MenuDelWholeAgenda ();
				break;

		case RET_MD_OLD:
				Ret = MenuDeleteOldEntries (*Day);
				break;
				
		case RET_MD_AREA:
				Ret = MenuDelArea (*Day);
				break;

		case RET_MD_DAY:
				Ret = MenuDelDay (*Day);
				break;
				
		case RET_MA_EDITDAY:
				Ret = EditDay (*Day);
				break;

		case RET_MA_MOVE:
				Ret = MenuMoveDay (Day);
				break;
				
		case RET_MA_SHORTCUT:
				Ret = MenuAgendaShortcut (*Day);
				break;
				
		case RET_MV_NORMAL_VIEW:
				D_AgendaViewMode = NORMAL_VIEW;
				Ret = ER_CHANGE_VIEW;
				break;
				
		case RET_MV_MONTH_VIEW:
				D_AgendaViewMode = SECOND_VIEW;
				Ret = ER_CHANGE_VIEW;
				break;
				
	}
	
	*Repaint = 1;
	if ( (DayBefore == *Day) && 
	     ( (idx == RET_MG_DAY) || (idx == RET_MG_WEEK) || (idx == RET_MG_YEAR)) ) *Repaint = 0;

	if ( (idx == RET_MD_DAY) && (Ret == CANCEL)) *Repaint = 0;
	if (DidWhat != NULL) *DidWhat = idx;

	if ( !(gr_Agenda->Exit || Ret == ER_CHANGE_VIEW) ) DrawMainCursor(ON, *Day);

	return Ret;
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int MenuGotoDay (unsigned int *Day)
{
	int		Ret = ER_SUCCESS;

	Ret = SelectDay (Day, MG_TITLE, MG_DAY_TEXT);	
	return Ret;
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int MenuGotoWeek (unsigned int *Day)
{
	int			Ret 			= ER_SUCCESS;
	char		Buffer[10];
	int			BufSpace[]		= {5};
	int			Offset[]		= {0};
	TDate		Date;
	int			n;
	
	memset (Buffer, 0, sizeof(Buffer));
	sprintf (Buffer, "%02d", GetWeek (*Day));
	if (RequestBox (MG_TITLE, MG_WEEK_TEXT, Buffer, BufSpace, 10, Offset, 1) == OK)
	{
		n = atoi (Buffer);
		if (n>0 && n<54)
		{
			GetDate (*Day, &Date);
			Date.MonthDay = 4;
			Date.Month = 1;
			*Day = GetDay (Date);
			*Day -= *Day % 7;
			*Day += --n*7;
		}
		else *Day -= *Day % 7;
	}
	
	return Ret;
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int MenuGotoYear (unsigned int *Day)
{
	int			Ret			= ER_SUCCESS;
	char		Buffer[10];
	int			BufSpace[]	= {5};
	int			Offset[]	= {0};
	TDate		Date;
	int			n;
	
	memset (Buffer, 0, sizeof(Buffer));
	GetDate (*Day, &Date);
	sprintf (Buffer, "%d", Date.Year);
	if (RequestBox (MG_TITLE, MG_YEAR_TEXT, Buffer, BufSpace, 11, Offset, 1) == OK)
	{
		Date.MonthDay = 1;
		Date.Month = 1;
		n = atoi (Buffer);
		if ( (n >= 2000) && (n <= 2099) ) Date.Year = n;
		if ( (n >= 0) && (n <= 99) ) Date.Year = n + 2000; 
		*Day = GetDay (Date);
	}
	
	return Ret;
		
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int	MenuDelDay (unsigned int Day)
{
	int			Ret				= ER_SUCCESS;
	
	if (ReadDay (Day, NULL) != NULL)
	{
		if ( (Ret = MsgBox (MD_TITLE, MD_DAY_T, BT_YES, BT_NO)) == OK) Ret = DeleteDay(Day);
	}
	else Ret = CANCEL;

	return Ret;
	
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int MenuDelWholeAgenda ()
{
	int			Ret		= ER_SUCCESS;
	
	if ( MsgBox (MD_TITLE, MD_WHOLE_T, BT_OK, BT_CANCEL) == OK)
	{
		Ret = DeleteAgenda ();
	} 
		
	return Ret;
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int MenuDelArea (unsigned int Day)
{
	int				Ret				= ER_SUCCESS;
	char			Buffer[30];
	int				BufSpace[]		= {10, 10};
	int				Offset[]		= {0, 11};
	unsigned int	n;
	TDate			DateA;
	TDate			DateB;
	unsigned int	DayA;
	unsigned int	DayB;
	int				Step			= 1;				// count direction: if date2 < date1 : -1
	char			*Msg			= MD_AREA_MSG;
	
	memset (Buffer, 0, sizeof(Buffer));
	GetDate (Day, &DateA);
	GetDate (Day, &DateB);
	getDateString (Day, NULL, Buffer, FLAG_USE_YEAR | FLAG_LONG_YEAR, NULL);
	strcpy (Buffer + 11, Buffer);
	

	if (RequestBox (MD_TITLE, MD_AREA_T, Buffer, BufSpace, 12, Offset, 2) == OK)
	{
		Ret = GetDayFromStrDate (Buffer, &DateA, &DayA, 1);
		Ret |= GetDayFromStrDate (Buffer + 11, &DateB, &DayB, 1);

		if (Ret == ER_SUCCESS)
		{
			getDateString (DayA, NULL, Msg + MD_AREA_MSG_O1, FLAG_USE_YEAR | FLAG_LONG_YEAR, NULL);
			getDateString (DayB, NULL, Msg + MD_AREA_MSG_O2, FLAG_USE_YEAR | FLAG_LONG_YEAR, NULL);
			poke (Msg + MD_AREA_MSG_O3, ' ');	// change \0 of inputbox to a space
			if (MsgBox (MD_TITLE, Msg, BT_YES, BT_NO) == OK)
			{
				if (DayB < DayA) Step = -1;			
				for (n = DayA; n != (DayB + Step); n += Step)
				{
					Ret |= DeleteDay (n);
				}
			}
		}

	}

	return Ret;	
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int	SelectDay (unsigned int *Day, char *Title, char *Text)
{
	char		Request[] 	= "0000000000";
	TDate		Date;
	int			Ret 		= ER_SUCCESS;
	int			BufSpace[]	= {10};
	int			Offset[]	= {0};
	
	GetDate (*Day, &Date);
	getDateString (*Day, NULL, Request, FLAG_USE_YEAR | FLAG_LONG_YEAR, NULL); 
	
	if ( (Ret = RequestBox (Title, Text, Request, BufSpace, 12, Offset, 1)) == OK)
	{
		Ret = GetDayFromStrDate (Request, &Date, Day, 1);
	}

	return (Ret);
}

// --------------------------------------------------------------------------

int MenuDeleteOldEntries (unsigned int Day)
{
	int				Ret		= ER_SUCCESS;
	unsigned int	today;
	unsigned int	i;
	char			buffer[20];
	
	if (getToday (&today) == ER_SUCCESS) Day = today;
	getDateString (Day, NULL, buffer, FLAG_USE_YEAR | FLAG_LONG_YEAR, NULL);


	memcpy (MSG_DEL_OLD + MSG_DEL_OLD_OFS, buffer, 10);
	if ( MsgBox (MD_TITLE, MSG_DEL_OLD, BT_YES, BT_NO) == OK)
	{
		for (i = MIN_DAY; i < Day; i++)
		{
			Ret |= DeleteDay (i);
		}
	}
		
	return Ret;
}

// --------------------------------------------------------------------------

int MenuGotoNextEntry (unsigned int *Day)
{
	int				Ret 		= ER_SUCCESS;
	TAgendaHeader	*Header		= (TAgendaHeader *)((char *)(gr_Agenda->DataFile.DataPtr + gr_Agenda->DataFile.Header->AgendaPtr));
	unsigned int	minDay		= 0xFFFF;
	unsigned int	minDiff		= 0xFFFF;
	long			diff;
	
	// --- if there is no entry in agenda section
	if (gr_Agenda->DataFile.Header->AgendaSize != 2)
	{
		stBusy();
	
		while ( Header->Flags != FLAG_ET_DATAEND )
		{
			if (Header->Day < minDay) minDay = Header->Day;
			diff = Header->Day - *Day;
			if (diff > 0 && diff < minDiff) minDiff = Header->Day - *Day; 
			Header = (TAgendaHeader *)((char *)Header + Header->Size);
		}
		
		if (minDiff == 0xFFFF) *Day = minDay;
		else *Day += minDiff;

		stIdle();
	}
	else
	{
		Ret = ER_NOENTRY;
		MsgBox (MSG_ER_TITLE, MSG_ER_NOENTRY, BT_OK, BT_NONE); 
	}
	
	return Ret;
}

// --------------------------------------------------------------------------

int MenuGotoToday (unsigned int *Day)
{
	int				Ret = ER_SUCCESS;

	Ret = getToday (Day);
	
	return Ret;
}

// --------------------------------------------------------------------------

int MenuMoveDay (unsigned int *Day)
{
	int				Ret		= ER_SUCCESS;
	unsigned int	destDay	= *Day;
	char			*sd;
	char			*dd;
	HANDLE			hbuf	= H_NULL;
	char			*pbuf;
	
	sd = ReadDay (*Day, NULL);
	if (sd != NULL)
	{
		Ret = SelectDay (&destDay, MAM_TITLE, MM_DAY_TEXT);	
		if (Ret == ER_SUCCESS && destDay != *Day)
		{
			dd = ReadDay (destDay, NULL);
			if ( (hbuf = HeapAlloc (strlen (sd) + strlen (dd) + 4)) == H_NULL) Ret = ER_MALLOC;
			else
			{
				pbuf = HeapDeref (hbuf);
				if (dd)
				{
					strcpy (pbuf, dd);
					strcat (pbuf, "\r\r");
					strcat (pbuf, sd);
				}
				else strcpy (pbuf, sd);
				
				Ret = WriteDay (destDay, hbuf);
				if (Ret == ER_SUCCESS)
				{
					Ret = DeleteDay (*Day);
					*Day = destDay;
				}
			}
		}
	}
	else Ret = CANCEL;

	HeapFreeHNULL (&hbuf);

	return Ret;
}

// --------------------------------------------------------------------------

int MenuAgendaShortcut (unsigned int Day)
{
	int				Ret		= ER_SUCCESS;
	TAgendaHeader	*header;
	
	if (ReadDay (Day, &header))	Ret = MenuShortcut ((TEntryHeader *)header);
		
	return Ret;
}

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
