// C Source File

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Title:        AGENDA V4.2  oooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Author:       Adrian Bader o - o A.Bader@gmx.ch ooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
// -- Best viewed with TAB-STOP 4! ------------------------------------------
// --------------------------------------------------------------------------


#include "IncludeAll.h"

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int MenuShortcut (TEntryHeader *header)
{
	int				Ret		= ER_SUCCESS;
	HANDLE			handle	= H_NULL;
	int				idx;
	unsigned int	key;

	Ret = makeShortcutPopup (&handle, header->Shortcut);
	if (Ret == ER_SUCCESS)
	{
		getShortcut (-1, NULL, &header->Shortcut, &idx);
		idx += 2;
		idx = PopupDo (handle, CENTER, CENTER, idx);
		if (idx)
		{
			idx -= 2;
			getShortcut (idx, NULL, &key, NULL);
			header->Shortcut = key;
		}
		
	}
	HeapFreeHNULL (&handle);

	return Ret;
}


int makeShortcutPopup (HANDLE *handle, int ownKey)
{
// make popup handle with all unused shortcuts to select
// ownKey: if != -1, it is the shortcut to add even if it is used
// free the handle after popupdo!
// returnvalue of popupdo will be the lookuptable number of
// the selected shortcut

	int		Ret						= ER_SUCCESS;
	char	list[NUM_OF_SHORTCUTS];
	int		i;
	char	*name;
	int		ownKeyIdx;
		
	// --- list will contain 0 or 1: 0, if the appropriate shortcut
	// --- is unused, otherwise 1.
	getUsedShortcuts (list);
	
	// --- add own shortcut, if there is one
	if (ownKey != -1)
	{
		getShortcut (-1, NULL, &ownKey, &ownKeyIdx);
		list[ownKeyIdx] = 0;
	}
		
	*handle = PopupNew (NULL, 0);
	if (*handle == H_NULL) Ret = ER_MALLOC;
	else
	{
		PopupAddText (*handle, -1, TEXT_NONE, 1);		// TEXT_NONE = "none"
		for (i = 0; (i < NUM_OF_SHORTCUTS) && (Ret == ER_SUCCESS); i++)
		{
			// --- used shortcut: list[i] == 1
			if (list[i] == 0)
			{
				getShortcut (i, &name, NULL, NULL);
				if ( PopupAddText (*handle, -1, name, i+2) == H_NULL)
				{
					Ret = ER_MALLOC;
					HeapFreeHNULL (handle);
				}
			}
		}
	}
	
	
	return Ret;
}

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int clbUsedShortcuts (TEntryHeader *header, void *list, int int1)
{
	// --- must return 0 (used to browse all entries)
	int		idx;
	
	if (header->Shortcut != 0)
	{
		getShortcut (-1, NULL, &header->Shortcut, &idx);
		((char *)(list))[idx] = 1;
	}
	
	return 0;
}

// --------------------------------------------------------------------------

void getUsedShortcuts (char *list)
{
	memset (list, 0, NUM_OF_SHORTCUTS);
	browseEntries (&clbUsedShortcuts, list, 0);
}


// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int clbAssoziatedKey (TEntryHeader *header, void *ptr1, int key)
{
	if (header->Shortcut == (unsigned)key)
	{	
		*((TEntryHeader **)ptr1) = header;
		// --- stop browsing now
		return 1;
	}

	// --- continue browsing
	return 0;
}

// --------------------------------------------------------------------------

TEntryHeader *getAssoziatedShortcut (int key)
{
	TEntryHeader	*header	= NULL;
	
	browseEntries (&clbAssoziatedKey, &header, key);	
	return header;
}

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

void getShortcut (int idx, char **name, int *key, int *kidx)
{
	unsigned int		i;
	static TShortcut	shortcuts[] = {
										{"F1", KEY_F1},
										{"F2", KEY_F2},
										{"F3", KEY_F3},
										{"F4", KEY_F4},
										{"F5", KEY_F5},
										{"F6", KEY_F6},
										{"F7", KEY_F7},
										{"F8", KEY_F8},
										{"A", 'a'},
										{"B", 'b'},
										{"C", 'c'},
										{"D", 'd'},
										{"E", 'e'},
										{"F", 'f'},
										{"G", 'g'},
										{"H", 'h'},
										{"I", 'i'},
										{"J", 'j'},
										{"K", 'k'},
										{"L", 'l'},
										{"M", 'm'},
										{"N", 'n'},
										{"O", 'o'},
										{"P", 'p'},
										{"Q", 'q'},
										{"R", 'r'},
										{"S", 's'},
										{"T", 't'},
										{"U", 'u'},
										{"V", 'v'},
										{"W", 'w'},
										{"X", 'x'},
										{"Y", 'y'},
										{"Z", 'z'},
										{"0", '0'},
										{"1", '1'},
										{"2", '2'},
										{"3", '3'},
										{"4", '4'},
										{"5", '5'},
										{"6", '6'},
										{"7", '7'},
										{"8", '8'},
										{"9", '9'}
									  };
									  
	if (idx != -1)
	{
		if (name) *name = shortcuts[idx].name;
		if (key) *key = shortcuts[idx].key;
	}
	else
	{
		if (key && kidx)
		{
			*kidx = -1;
			for (i = 0; i < sizeof(shortcuts) / sizeof(shortcuts[0]); i++)
			{
				if (shortcuts[i].key == *key) *kidx = i;
			}
		}
	}
}

// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
