// C Source File

// --------------------------------------------------------------------------
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Title:        AgndConv V.E oooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oo Date:         November 2003 ooooooooooooooooooooooooooooooooooooooooooo
// oo Author:       Adrian Bader o - o A.Bader@gmx.ch ooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
// --------------------------------------------------------------------------
// -- Best viewed with TAB-STOP 4! ------------------------------------------
// --------------------------------------------------------------------------

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------


#include "BuildOptions.h"
#include <tigcclib.h>

#include "agndconv.h"
#include "consts.h"
#include "V2.h"

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

int Update1to2 (HANDLE handle)
{
	int				Ret				= ER_SUCCESS;
	unsigned int	Size;
	HANDLE			nHandle;
	char			*pFile;
	unsigned int	OldDay;
	unsigned int	OldFlags;
	char			OldPass[10];
	unsigned int	*DATPtr;
	
	if (MsgBox ((char *)"Conversion", (char *)"Update agnddata version 1\0to version 2?\0", BT_YES, BT_NO) == OK)
	{
		Size = peek_w (HeapDeref (handle))+2;
		Size += 4;
		nHandle = HeapRealloc (handle, Size);
		if (nHandle == H_NULL) Ret = ER_MALLOC;
		else
		{
			pFile = HeapDeref (nHandle);
			poke_w (pFile, Size-2);
			OldFlags = peek_w (pFile + 2);
			OldDay = peek_w (pFile + 4);
			memset (OldPass, 0, 10);
			memmove (OldPass, pFile + 6, 9);
			if (OldFlags & FLAG_ENCODED)
			{
				EncodeData (pFile + 16, ENCODE_KEY_D, Size -4 -N_TERM_BYTES - 16 );
			}
			memmove (pFile + 20, pFile + 16, Size - 20);	// DATA_PTR was 20
			poke_w (pFile + 2, 0xFF02);						// VERSION_PTR was 2
			poke_w (pFile + 4, OldFlags);					// FLAGS_PTR was 4
			poke_w (pFile + 6, OldDay);						// DAY_PTR was 
			memmove (pFile + 8, OldPass, 10);				// PASS_PTR was 
			poke_w (pFile + 18, 0);							// NUMSTARTS_PTR was 
			DATPtr = (int *)(pFile + 20);					// AGENDA_PTR was 
			
			while (*DATPtr)
			{
				DATPtr++;
				*DATPtr += 4;
				DATPtr++;
			}												
		if (OldFlags & FLAG_ENCODED) EncodeData (pFile + 20, ENCODE_KEY_D, Size -N_TERM_BYTES - 20 );
		}
		MsgBox ((char *)"Conversion", (char *)"File agnddata successfully converted\0to version 2!\0", BT_OK, BT_NONE);
	}
	else Ret = CANCEL;
	
	return Ret;
}

// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------

